
bool roughlyEquals(vec4 colour, vec4 compare_colour) {
    // compares if 2 colours are equal to eachother within a range of error
    float ERROR_RANGE = 0.0001;

    vec4 compare_lower = compare_colour - ERROR_RANGE;
    vec4 compare_upper = compare_colour + ERROR_RANGE;

    if( (colour.r >= compare_lower.r && colour.r <= compare_upper.r)
     && (colour.g >= compare_lower.g && colour.g <= compare_upper.g)
     && (colour.b >= compare_lower.b && colour.b <= compare_upper.b)
     && (colour.a >= compare_lower.a && colour.a <= compare_upper.a) ) {
        return true;
    }else{
        return false;
    }
}

bool roughlyEquals(vec3 colour, vec3 compare_colour) {
    // compares if 2 colours are equal to eachother within a range of error
    float ERROR_RANGE = 0.0001;

    vec3 compare_lower = compare_colour - ERROR_RANGE;
    vec3 compare_upper = compare_colour + ERROR_RANGE;

    if( (colour.r >= compare_lower.r && colour.r <= compare_upper.r)
     && (colour.g >= compare_lower.g && colour.g <= compare_upper.g)
     && (colour.b >= compare_lower.b && colour.b <= compare_upper.b) ) {
        return true;
    }else{
        return false;
    }
}

vec4 getGradientWithResolution(vec4 gradientColor, vec4 gradientResolution) {
    return abs(floor( gradientColor * gradientResolution ) / gradientResolution);
}